; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
Point2fT union
	s POINT <>
	T dd ?,?
Point2fT ends
Vector3fT union
 struct s
	X dd ?
	Y dd ?
	Z dd ?
 ends
 T dd 3 dup(?)
Vector3fT ends
Quat4fT union
 struct s
        X dd ?
	Y dd ?
	Z dd ? 
	W dd ?
 ends
 T dd 4 dup(?)
Quat4fT ends;      //A 4-element tuple represented by single-precision floating point x,y,z,w coordinates. 
Matrix3fT union 
 struct s
;column major
        union
		M00 dd ?; 
		XX  dd ?; 
		SX  dd ?; };XAxis.X and Scale X
	ends
        union
		M10 dd ?; 
		XY  dd ?; };XAxis.Y
	ends
        union
		M20 dd ?; 
		XZ  dd ?; };XAxis.Z
	ends
        union
		M01 dd ?; 
		YX  dd ?; };YAxis.X
	ends
        union
		M11 dd ?;
		YY dd ?;
		SY dd ?; };  //YAxis.Y and Scale Y
	ends
        union
		M21 dd ?;
		YZ dd ?;             };  //YAxis.Z
	ends
        union
		M02 dd ?;
		ZX dd ?;             };  //ZAxis.X
	ends
        union
		M12 dd ?;
		ZY dd ?;             };  //ZAxis.Y
	ends
        union
		M22 dd ?; 
		ZZ  dd ?; 
		SZ  dd ?; };ZAxis.Z and Scale Z
	ends
 ends
 M dd 9 dup(?)
Matrix3fT ends;A single precision floating point 3 by 3 matrix. 
Matrix4fT union
    struct s
;column major
    union
	M00 dd ? 
	XX  dd ? 
	SX  dd ?
    ends;  //XAxis.X and Scale X
    union
	M10 dd ?
	XY dd ?
    ends;  //XAxis.Y
    union
	M20 dd ?
	XZ dd ?
    ends;  //XAxis.Z
    union
	M30 dd ?
	XW dd ?;XAxis.W
    ends
    union
	M01 dd ?
	YX dd ?;YAxis.X
    ends
    union
	M11 dd ?
	YY dd ?
	SY dd ?; };  //YAxis.Y and Scale Y
    ends
    union
	M21 dd ?
	YZ dd ?;YAxis.Z
    ends
    union
	M31 dd ?
	YW dd ?;YAxis.W
    ends
    union
	M02 dd ?
	ZX dd ?
    ends;  //ZAxis.X
    union
	M12 dd ?
	ZY dd ?
    ends;  //ZAxis.Y
    union
	M22 dd ?
	ZZ dd ?
	SZ dd ?
    ends;  //ZAxis.Z and Scale Z
    union
	M32 dd ?
	ZW dd ?
    ends;  //ZAxis.W
    union
	M03 dd ?
	TX dd ?
    ends;  //Trans.X
    union
	M13 dd ?
	TY dd ?
    ends;  //Trans.Y
    union
	M23 dd ?
	TZ dd ?
    ends;  //Trans.Z
    union
	M33 dd ?
	TW dd ?
	SW dd ?
    ends;  //Trans.W and Scale W
   ends;
   M dd 16 dup (?)
Matrix4fT ends;     //A single precision floating point 4 by 4 matrix
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_LBUTTONDOWN
	je      wmLBUTTONDOWN
        cmp	edx,WM_RBUTTONDOWN
	je      wmRBUTTONDOWN
        cmp	edx,WM_LBUTTONUP
	je      wmLBUTTONUP
        cmp	edx,WM_RBUTTONUP
	je      wmRBUTTONUP
        cmp	edx,WM_MOUSEMOVE
	je      wmMOUSEMOVE
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	gluDeleteQuadric,quadratic
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:cmp	isRClicked,0; If Right Mouse Clicked, Reset All Rotations
	jz	@f
	mov	ecx,offset LastRot
	invoke	Matrix3fSetIdentity;Matrix3fSetIdentity(&LastRot); Reset Rotation
	mov	ecx,offset ThisRot
	invoke	Matrix3fSetIdentity;Matrix3fSetIdentity(&ThisRot); Reset Rotation
	mov	edx,offset ThisRot
	mov	ecx,offset Transform
	invoke	Matrix4fSetRotationFromMatrix3f;Matrix4fSetRotationFromMatrix3f(&Transform, &ThisRot); Reset Rotation
@@:	cmp	isDragging,0;if (!isDragging)	Not Dragging
	jnz	@f
	cmp	isClicked,0;if (isClicked)// First Click
	jz	@3
	mov	isDragging,TRUE;isDragging = true; Prepare For Dragging
	mov	rdi,offset LastRot; Set Last Static Rotation To Last Dynamic One
	mov	rsi,offset ThisRot
	mov	ecx,9
	rep	movsd;LastRot = ThisRot
	mov	ecx,offset MousePt
; Update Start Vector And Prepare For Dragging
	mov	edx,offset StVec
	invoke	_mapToSphere
        jmp	@3
@@:	cmp	isClicked,0;if (isClicked)// Still Clicked, So Still Dragging
	jz	@4
	mov	edx,offset ThisQuat
	mov	ecx,offset MousePt
	invoke	drag;ArcBall.drag(&MousePt, &ThisQuat);// Update End Vector And Get Rotation As Quaternion
	mov	edx,offset ThisQuat
	mov	ecx,offset ThisRot
	invoke	Matrix3fSetRotationFromQuat4f;Matrix3fSetRotationFromQuat4f(&ThisRot, &ThisQuat);// Convert Quaternion Into Matrix3fT
	mov	edx,offset LastRot
	mov	ecx,offset ThisRot
	invoke	Matrix3fMulMatrix3f;Matrix3fMulMatrix3f(&ThisRot, &LastRot);// Accumulate Last Rotation Into This One
	mov	edx,offset ThisRot
	mov	ecx,offset Transform
	invoke	Matrix4fSetRotationFromMatrix3f;Matrix4fSetRotationFromMatrix3f(&Transform, &ThisRot);// Set Our Final Transform's Rotation From This One
	jmp	@3
; ---------------------------------------------------------------------------
@4:	and	isDragging,FALSE
@3:	invoke	InvalidateRect,hWin,0,0
	jmp	wmBYE
wmLBUTTONDOWN:mov isLClicked,TRUE
	jmp	default
wmRBUTTONDOWN:mov isRClicked,TRUE
	jmp	default
wmLBUTTONUP:mov isLClicked,FALSE
	jmp	default
wmRBUTTONUP:mov isRClicked,FALSE
	jmp	default
wmMOUSEMOVE:movzx eax,r9w
	cvtsi2ss xmm0,eax
	movss	MousePt.s.x,xmm0;MousePt.s.X = (GLfloat)LOWORD(lParam)
	mov	eax,r9d
	shr	eax,10h
	cvtsi2ss xmm0,eax
	movss	MousePt.s.y,xmm0;MousePt.s.Y = (GLfloat)HIWORD(lParam);
	mov	al,r8b
	and	al,MK_LBUTTON
	mov	isClicked,al;isClicked   = (LOWORD(wParam) & MK_LBUTTON) ? true : false;
	mov	al,r8b
	and	al,MK_RBUTTON
	shr	al,1
	mov	isRClicked,al;isRClicked  = (LOWORD(wParam) & MK_RBUTTON) ? true : false;
	jmp	default
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'? 1Bh
	je	wmDESTROY
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;,0, 0, 0, 0.5; Black Background
	movsd	xmm0,constd1
	invoke	glClearDepth;1 	Depth Buffer Setup
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing (Less Or Equal)
	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing
	invoke	glShadeModel,GL_FLAT; Select Flat Shading (Nice Definition Of Objects)
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Set Perspective Calculations To Most Accurate
	invoke	gluNewQuadric; Create A Pointer To The Quadric Object
	mov	quadratic,rax
	invoke	gluQuadricNormals,eax, GLU_SMOOTH; Create Smooth Normals
	invoke	gluQuadricTexture,quadratic, GL_TRUE; Create Texture Coords

	invoke	glEnable,GL_LIGHT0; Enable Default Light
	invoke	glEnable,GL_LIGHTING; Enable Lighting

	invoke	glEnable,GL_COLOR_MATERIAL; Enable Color Material

	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
	cvtsi2ss xmm1,h
	cvtsi2ss xmm0,w
	invoke	setBounds
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke	glLoadIdentity; Reset The Current Modelview Matrix
	movss	xmm2,const_6
	xorps	xmm1,xmm1
	movss	xmm0,const_1_5
	invoke	glTranslatef;-1.5,0,-6	Move Left 1.5 Units And Into The Screen 6.0

	invoke	glPushMatrix; Prepare Dynamic Transform
	mov	ecx,offset Transform
	invoke	glMultMatrixf;Transform.M; Apply Dynamic Transform
	movss	xmm2,const1
	movss	xmm1,const0_75
	movss	xmm0,xmm1
	invoke	glColor3f;0.75,0.75,1.0
	movss	xmm1,const1
	movss	xmm0,const0_3
	invoke	Torus;0.3,1.0
	invoke	glPopMatrix; Unapply Dynamic Transform

	invoke	glLoadIdentity; Reset The Current Modelview Matrix
	movss	xmm2,const_6
	xorps	xmm1,xmm1
	movss	xmm0,const1_5
	invoke	glTranslatef;1.5,0,-6	 Move Right 1.5 Units And Into The Screen 7.0

	invoke	glPushMatrix; Prepare Dynamic Transform
	mov	ecx,offset Transform
	invoke	glMultMatrixf;Transform.M; Apply Dynamic Transform
	movss	xmm2,const0_75
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glColor3f;1,0.75,0.75
	movsd	xmm1,constd1_3
	invoke	gluSphere,quadratic,,20,20;
	invoke	glPopMatrix; Unapply Dynamic Transform


	invoke	glFlush; Flush The GL Rendering Pipeline
;   
	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn
WndProc	endp
;Set new bounds
setBounds proc NewWidth:dword, NewHeight:dword
	movss	NewWidth,xmm0 
	movss	NewHeight,xmm1
        comiss	xmm1,const1
	jbe	exit0
	comiss	xmm0,const1
	jbe	exit0;(NewWidth > 1.0) && (NewHeight > 1.0)
;Set adjustment factor for width/height
        movss	xmm2,const1
	subss	xmm0,xmm2
	mulss	xmm0,const0_5
	movss	xmm3,xmm2
	divss	xmm2,xmm0
	movss	AdjustWidth,xmm2;AdjustWidth = 1.0/((NewWidth - 1.0)*0.5);
	subss	xmm1,xmm3
	mulss	xmm1,const0_5
       	divss	xmm3,xmm1
	movss	AdjustHeight,xmm3;AdjustHeight = 1.0/((NewHeight - 1.0)*0.5);
exit0:	leave
	ret
setBounds endp
Torus		proc MinorRadius:dword,MajorRadius:dword
local	wrapFrac:dword
local	phi:dword
local	sinphi:dword
local	cosphi:dword
local	r:dword
local	temp2:dword
local	temp1:dword


	movss	MajorRadius, xmm1
	movss	MinorRadius, xmm0		
	push	rsi
	push	rdi	
	invoke	glBegin,GL_TRIANGLE_STRIP
	xor	esi,esi
@0:	or	edi,-1
@@:	mov	eax, edi
	cdq
	mov	ecx, 20
	idiv	ecx
	cvtsi2ss xmm0, edx
	divss	xmm0, const20
	movss	wrapFrac, xmm0
	mulss	xmm0,PI2
	movss	phi,xmm0;phi = PI2*wrapFrac
	invoke	sinf
	movss	sinphi,xmm0;sinphi = sin(phi)
	movss	xmm0, phi ;	
	invoke	cosf
	movss	cosphi, xmm0;cosphi = cos(phi)
	mulss	xmm0,MinorRadius 
	addss	xmm0,MajorRadius
	movss	r,xmm0;r = MajorRadius + MinorRadius*cosphi
	cvtsi2ss xmm0,esi
	addss	xmm0, wrapFrac;i%20+wrapFrac
	mulss	xmm0,const0_Pi;PI2*(i%20+wrapFrac)/20
	invoke	cosf
	mulss	xmm0, cosphi;cos(PI2*(i%20+wrapFrac)/20)*cosphi
	movss	temp2, xmm0
	cvtsi2ss xmm0,esi
	addss	xmm0, wrapFrac
	mulss	xmm0,const0_Pi
	invoke	sinf
	mulss	xmm0, cosphi
	movss	xmm2, temp2
	movss	xmm1, sinphi
	invoke	glNormal3f
	cvtsi2ss xmm0,esi
	addss	xmm0, wrapFrac
	mulss	xmm0,const0_Pi
	invoke	cosf
	mulss	xmm0, r
	movss	temp2, xmm0
	movss	xmm1, MinorRadius
	mulss	xmm1, sinphi
	movss	temp1, xmm1
	cvtsi2ss xmm0,esi; edx
	addss	xmm0, wrapFrac
	mulss	xmm0,const0_Pi
	invoke	sinf
	mulss	xmm0, r
	movss	xmm2, temp2
	movss	xmm1, temp1
	invoke	glVertex3f
	mov	eax, esi
	inc	eax
	cvtsi2ss xmm0, eax
	addss	xmm0, wrapFrac
	mulss	xmm0,const0_Pi
	movss	temp1,xmm0
	invoke	cosf
	mulss	xmm0, cosphi
	movss	temp2, xmm0
	movss	xmm0,temp1
	invoke	sinf
	mulss	xmm0, cosphi
	movss	xmm2, temp2
	movss	xmm1, sinphi
	invoke	glNormal3f
	movss	xmm0,temp1
	invoke	cosf
	mulss	xmm0, r
	movss	temp2, xmm0
	movss	xmm0,temp1
	invoke	sinf
	mulss	xmm0, r;r*sin((i+1%20+wrapFrac)*PI/10)
	movss	xmm2, temp2
	movss	xmm1, MinorRadius
	mulss	xmm1, sinphi;MinorRadius*sinphi
	invoke	glVertex3f
        inc	edi
	cmp	edi, 20
	jb	@b
	inc	esi
	cmp	esi, 20
	jb	@0
	invoke	glEnd
	pop	rdi
	pop	rsi
	leave
	retn
Torus	endp
;Sets this Matrix3 to identity
Matrix3fSetIdentity proc NewObj:qword
	mov	NewObj, rcx
	invoke	Matrix3fSetZero
;then set diagonal as 1
	mov	rax,NewObj
	movr	dword ptr [rax+20h],1.0;NewObj->s.M00 = 1.0
	movr	dword ptr [rax+10h],1.0;NewObj->s.M11 = 1.0
	movr	dword ptr [rax],1.0;NewObj->s.M22 = 1.0
	leave
	ret
Matrix3fSetIdentity endp
;Sets the rotational component (upper 3x3) of this matrix to the matrix
; values in the T precision Matrix3d argument; the other elements of
; this matrix are unchanged; a singular value decomposition is performed
; on this object's upper 3x3 matrix to factor out the scale, then this
; object's upper 3x3 matrix components are replaced by the passed rotation
; components, and then the scale is reapplied to the rotational
; components.
; @param m1 T precision 3x3 matrix
Matrix4fSetRotationFromMatrix3f proc NewObj:qword, m1:qword
local	scale:dword

	mov	NewObj,rcx
	mov	m1,rdx
	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0;assert(NewObj && m1);
	invoke	Matrix4fSVD,,NULL,NULL
        movss	scale,xmm0
	invoke	Matrix4fSetRotationScaleFromMatrix3f,NewObj, m1;
        movss	xmm1,scale
	invoke	Matrix4fMulRotationScale,NewObj
exit0:	leave
	ret
Matrix4fSetRotationFromMatrix3f endp
drag proc NewPt:qword,NewRot:qword
LOCAL	Perp:Vector3fT

	mov	NewPt,rcx
	mov	NewRot,rdx
;Map the point to the sphere
	mov	edx,offset EnVec
	invoke	_mapToSphere;(NewPt, &this->EnVec);
;Return the quaternion equivalent to the rotation
	cmp	NewRot,0;if (NewRot)
	jz	exit0
;Compute the vector perpendicular to the begin and end vectors
	lea	ecx,Perp
	mov	edx,offset StVec
	mov	r8d,offset EnVec
	invoke	Vector3fCross;(&Perp, &this->StVec, &this->EnVec);
;Compute the length of the perpendicular vector
	lea	ecx,Perp
	invoke	Vector3fLengthSquared;NewObj
	sqrtss	xmm0,xmm0;sqrt(Vector3fLengthSquared(NewObj))
	comiss	xmm0, Epsilon
	jbe	@f;if (Vector3fLength(&Perp) > Epsilon)   if its non-zero
;We're ok, so return the perpendicular vector as the transform after all
	mov	rax,NewRot
	movss	xmm0,Perp.s.X
	movss	[rax].Quat4fT.s.X,xmm0;NewRot->s.X = Perp.s.X;
	movss	xmm0,Perp.s.Y
	movss	[rax].Quat4fT.s.Y,xmm0;NewRot->s.Y = Perp.s.Y;
	movss	xmm0,Perp.s.Z
	movss	[rax].Quat4fT.s.Z,xmm0;NewRot->s.Z = Perp.s.Z;
;In the quaternion values, w is cosine (theta / 2), where theta is rotation angle
	mov	edx,offset EnVec
	mov	ecx,offset StVec
	invoke	Vector3fDot
	mov	rax,NewRot
	movss	[rax].Quat4fT.s.W,xmm0;NewRot->s.W=Vector3fDot(&this->StVec, &this->EnVec)
	jmp	exit0
@@:;else if its zero
;The begin and end vectors coincide, so return an identity transform
	mov	rcx,NewRot
	and	[rax].Quat4fT.s.X,0;NewRot->s.X = 0
	and	[rax].Quat4fT.s.Y,0;NewRot->s.Y = 0
	and	[rax].Quat4fT.s.Z,0;NewRot->s.Z = 0
	and	[rax].Quat4fT.s.W,0;NewRot->s.W = 0
exit0:	leave
	ret
drag endp
;Sets the value of this matrix to the matrix conversion of the
; quaternion argument. 
; @param q1 the quaternion to be converted 

;$hack this can be optimized some(if s == 0)
Matrix3fSetRotationFromQuat4f proc NewObj:qword,q1:qword;Matrix3fT* NewObj, const Quat4fT* q1)
local	n:dword
local	s:dword
local	xs:dword
local	ys:dword
local	zs:dword
local	wx:dword
local	wy:dword
local	wz:dword
local	xx:dword
local	xy:dword
local	xz:dword
local	yy:dword
local	yz:dword
local	zz:dword

	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0;assert(NewObj && q1);
	movss	xmm0,[rdx].Quat4fT.s.X
	mulss	xmm0,xmm0
	movss	xmm1,[rdx].Quat4fT.s.Y
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,[rdx].Quat4fT.s.Z
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,[rdx].Quat4fT.s.W
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	n,xmm0;n = (q1->s.X * q1->s.X) + (q1->s.Y * q1->s.Y) + (q1->s.Z * q1->s.Z) + (q1->s.W * q1->s.W);
	xorps	xmm1,xmm1
	comiss	xmm0,xmm1
	jna	@f
	movss	xmm1,const2
	divss	xmm1,xmm0
@@:	movss	s,xmm1;s = (n > 0) ? (2.0/n) : 0
	movss	xmm0,[rdx].Quat4fT.s.X
	mulss	xmm0,xmm1
	movss	xs,xmm0;xs = q1->s.X * s
	movss	xmm0,[rdx].Quat4fT.s.Y
	mulss	xmm0,xmm1
	movss	ys,xmm0;ys = q1->s.Y * s
	movss	xmm0,[rdx].Quat4fT.s.Z
	mulss	xmm0,xmm1
	movss	zs,xmm0;zs = q1->s.Z * s
	movss	xmm0,[rdx].Quat4fT.s.W
	mulss	xmm0,xs
	movss	wx,xmm0;wx = q1->s.W * xs
	movss	xmm0,[rdx].Quat4fT.s.W
	mulss	xmm0,ys
	movss	wy,xmm0;wy = q1->s.W * ys
	movss	xmm0,[rdx].Quat4fT.s.W
	mulss	xmm0,zs
	movss	wz,xmm0;wz = q1->s.W * zs;
	movss	xmm0,[rdx].Quat4fT.s.X
	mulss	xmm0,xs
	movss	xx,xmm0;xx = q1->s.X * xs
	movss	xmm0,[rdx].Quat4fT.s.X
	mulss	xmm0,ys
	movss	xy,xmm0;xy = q1->s.X * ys
	movss	xmm0,[rdx].Quat4fT.s.X
	mulss	xmm0,zs
	movss	xz,xmm0;xz = q1->s.X * zs;
	movss	xmm0,[rdx].Quat4fT.s.Y
	mulss	xmm0,ys
	movss	yy,xmm0;yy = q1->s.Y * ys
	movss	xmm0,[rdx].Quat4fT.s.Y
	mulss	xmm0,zs
	movss	yz,xmm0;yz = q1->s.Y * zs
	movss	xmm0,[rdx].Quat4fT.s.Z
	mulss	xmm0,zs
	movss	zz,xmm0;zz = q1->s.Z * zs;
	movss	xmm0,const1
        subss	xmm0,yy
        subss	xmm0,zz
	movss	[rcx].Matrix3fT.s.XX,xmm0;NewObj->s.XX = 1.0 - (yy + zz)
	movss	xmm0,xy
        subss	xmm0,wz
	movss	[rcx].Matrix3fT.s.YX,xmm0;NewObj->s.YX = xy - wz
	movss	xmm0,xz
        addss	xmm0,wy
	movss	[rcx].Matrix3fT.s.ZX,xmm0;NewObj->s.ZX = xz + wy;
	movss	xmm0,xy
        addss	xmm0,wz
	movss	[rcx].Matrix3fT.s.XY,xmm0;NewObj->s.XY = xy + wz
	movss	xmm0,const1
        subss	xmm0,xx
        subss	xmm0,zz
	movss	[rcx].Matrix3fT.s.YY,xmm0;NewObj->s.YY = 1.0 - (xx + zz)
	movss	xmm0,yz
        subss	xmm0,wx
	movss	[rcx].Matrix3fT.s.ZY,xmm0;NewObj->s.ZY = yz - wx;
	movss	xmm0,xz
        subss	xmm0,wy
	movss	[rcx].Matrix3fT.s.XZ,xmm0;NewObj->s.XZ = xz - wy
	movss	xmm0,yz
        addss	xmm0,wx
	movss	[rcx].Matrix3fT.s.YZ,xmm0;NewObj->s.YZ = yz + wx
	movss	xmm0,const1
        subss	xmm0,yy
        subss	xmm0,xx
	movss	[rcx].Matrix3fT.s.ZZ,xmm0;NewObj->s.ZZ = 1.0 - (xx + yy)
exit0:	leave
	ret
Matrix3fSetRotationFromQuat4f endp
;Sets the value of this matrix to the result of multiplying itself
; with matrix m1. 
; @param m1 the other matrix 
Matrix3fMulMatrix3f proc NewObj:qword, m1:qword;Matrix3fT* NewObj, const Matrix3fT* m1)
local	Result:Matrix3fT ;safe not to initialize
	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0;assert(NewObj && m1)
; alias-safe way.
	movss	xmm0,[rcx].Matrix3fT.s.M00
	mulss	xmm0,[rdx].Matrix3fT.s.M00
	movss	xmm1,[rcx].Matrix3fT.s.M01
	mulss	xmm1,[rdx].Matrix3fT.s.M10
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M02
	mulss	xmm1,[rdx].Matrix3fT.s.M20
	addss	xmm0,xmm1
	movss	Result.s.M00,xmm0;Result.s.M00=(NewObj->s.M00*m1->s.M00)+(NewObj->s.M01 * m1->s.M10)+(NewObj->s.M02 * m1->s.M20);
	movss	xmm0,[rcx].Matrix3fT.s.M00
	mulss	xmm0,[rdx].Matrix3fT.s.M01
	movss	xmm1,[rcx].Matrix3fT.s.M01
	mulss	xmm1,[rdx].Matrix3fT.s.M11
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M02
	mulss	xmm1,[rdx].Matrix3fT.s.M21
	addss	xmm0,xmm1
	movss	Result.s.M01,xmm0;Result.s.M01=(NewObj->s.M00*m1->s.M01)+(NewObj->s.M01*m1->s.M11)+(NewObj->s.M02 * m1->s.M21);
	movss	xmm0,[rcx].Matrix3fT.s.M00
	mulss	xmm0,[rdx].Matrix3fT.s.M02
	movss	xmm1,[rcx].Matrix3fT.s.M01
	mulss	xmm1,[rdx].Matrix3fT.s.M12
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M02
	mulss	xmm1,[rdx].Matrix3fT.s.M22
	addss	xmm0,xmm1
	movss	Result.s.M02,xmm0;Result.s.M02=(NewObj->s.M00*m1->s.M02)+(NewObj->s.M01*m1->s.M12)+(NewObj->s.M02 * m1->s.M22);
	movss	xmm0,[rcx].Matrix3fT.s.M10
	mulss	xmm0,[rdx].Matrix3fT.s.M00
	movss	xmm1,[rcx].Matrix3fT.s.M11
	mulss	xmm1,[rdx].Matrix3fT.s.M10
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M12
	mulss	xmm1,[rdx].Matrix3fT.s.M20
	addss	xmm0,xmm1
	movss	Result.s.M10,xmm0;Result.s.M10=(NewObj->s.M10*m1->s.M00)+(NewObj->s.M11*m1->s.M10)+(NewObj->s.M12 * m1->s.M20);
	movss	xmm0,[rcx].Matrix3fT.s.M10
	mulss	xmm0,[rdx].Matrix3fT.s.M01
	movss	xmm1,[rcx].Matrix3fT.s.M11
	mulss	xmm1,[rdx].Matrix3fT.s.M11
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M12
	mulss	xmm1,[rdx].Matrix3fT.s.M21
	addss	xmm0,xmm1
	movss	Result.s.M11,xmm0;Result.s.M11=(NewObj->s.M10*m1->s.M01)+(NewObj->s.M11*m1->s.M11)+(NewObj->s.M12*m1->s.M21);
	movss	xmm0,[rcx].Matrix3fT.s.M10
	mulss	xmm0,[rdx].Matrix3fT.s.M02
	movss	xmm1,[rcx].Matrix3fT.s.M11
	mulss	xmm1,[rdx].Matrix3fT.s.M12
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M12
	mulss	xmm1,[rdx].Matrix3fT.s.M22
	addss	xmm0,xmm1
	movss	Result.s.M12,xmm0;Result.s.M12=(NewObj->s.M10*m1->s.M02)+(NewObj->s.M11*m1->s.M12)+(NewObj->s.M12 * m1->s.M22);
	movss	xmm0,[rcx].Matrix3fT.s.M20
	mulss	xmm0,[rdx].Matrix3fT.s.M00
	movss	xmm1,[rcx].Matrix3fT.s.M21
	mulss	xmm1,[rdx].Matrix3fT.s.M10
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M22
	mulss	xmm1,[rdx].Matrix3fT.s.M20
	addss	xmm0,xmm1
	movss	Result.s.M20,xmm0;Result.s.M20=(NewObj->s.M20*m1->s.M00)+(NewObj->s.M21*m1->s.M10)+(NewObj->s.M22*m1->s.M20);
	movss	xmm0,[rcx].Matrix3fT.s.M20
	mulss	xmm0,[rdx].Matrix3fT.s.M01
	movss	xmm1,[rcx].Matrix3fT.s.M21
	mulss	xmm1,[rdx].Matrix3fT.s.M11
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M22
	mulss	xmm1,[rdx].Matrix3fT.s.M21
	addss	xmm0,xmm1
	movss	Result.s.M21,xmm0;Result.s.M21=(NewObj->s.M20*m1->s.M01)+(NewObj->s.M21*m1->s.M11)+(NewObj->s.M22*m1->s.M21);
	movss	xmm0,[rcx].Matrix3fT.s.M20
	mulss	xmm0,[rdx].Matrix3fT.s.M02
	movss	xmm1,[rcx].Matrix3fT.s.M21
	mulss	xmm1,[rdx].Matrix3fT.s.M12
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix3fT.s.M22
	mulss	xmm1,[rdx].Matrix3fT.s.M22
	addss	xmm0,xmm1
	movss	Result.s.M22,xmm0;Result.s.M22=(NewObj->s.M20*m1->s.M02)+(NewObj->s.M21*m1->s.M12)+(NewObj->s.M22*m1->s.M22);
;copy result back to this
	push	rsi
	push	rdi
	mov	edi,ecx
	lea	esi,Result
	mov	ecx,4
	rep	movsq
	movsd;*NewObj = Result
	pop	rdi
	pop	rsi
exit0:	leave
	ret
Matrix3fMulMatrix3f endp
Matrix3fSetZero proc NewObj:qword
	push	rdi
	mov	edi,ecx
	mov	ecx,4
	xor	eax,eax
	rep	stosq
	stosd
	pop	rdi
	leave
	ret
Matrix3fSetZero endp
Matrix4fSVD proc NewObj:qword,rot3:qword,rot4:qword;Matrix4fT* NewObj, Matrix3fT* rot3, Matrix4fT* rot4
local	s:dword
local	n:dword
	mov	NewObj,rcx
	mov	rot3,rdx
	mov	rot4,r8
	or	ecx,ecx
	jz	exit0;assert(NewObj)
; this is a simple svd.
; Not complete but fast and reasonable.
; See comment in Matrix3d.
	movss	xmm0,[rcx].Matrix4fT.s.XX
	mulss	xmm0,xmm0;(NewObj->s.XX * NewObj->s.XX)
	movss	xmm1,[rcx].Matrix4fT.s.XY
	mulss	xmm1,xmm1;(NewObj->s.XY * NewObj->s.XY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.XZ
	mulss	xmm1,xmm1;(NewObj->s.XZ * NewObj->s.XZ)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.YX
	mulss	xmm1,xmm1;(NewObj->s.YX * NewObj->s.YX)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.YY
	mulss	xmm1,xmm1;(NewObj->s.YY * NewObj->s.YY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.YZ
	mulss	xmm1,xmm1;(NewObj->s.YZ * NewObj->s.YZ)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.ZX
	mulss	xmm1,xmm1;(NewObj->s.ZX * NewObj->s.ZX)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.ZY
	mulss	xmm1,xmm1;(NewObj->s.ZY * NewObj->s.ZY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.ZZ
	mulss	xmm1,xmm1;(NewObj->s.ZZ * NewObj->s.ZZ)
	addss	xmm0,xmm1
	divss	xmm0,const3
	sqrtss	xmm0,xmm0
	movss	s,xmm0;s=sqrt(++++++++)/3.0);
	or	edx,edx
	jz	@f;if (rot3)   if pointer not null
;this->getRotationScale(rot3);
	mov	eax,[rcx].Matrix4fT.s.XX
	mov	[rdx].Matrix3fT.s.XX,eax;rot3->s.XX = NewObj->s.XX;
	mov	eax,[rcx].Matrix4fT.s.XY
	mov	[rdx].Matrix3fT.s.XY,eax;rot3->s.XY = NewObj->s.XY;
	mov	eax,[rcx].Matrix4fT.s.XZ
	mov	[rdx].Matrix3fT.s.XZ,eax;rot3->s.XZ = NewObj->s.XZ;
	mov	eax,[rcx].Matrix4fT.s.YX
	mov	[rdx].Matrix3fT.s.YX,eax;rot3->s.YX = NewObj->s.YX; 
	mov	eax,[rcx].Matrix4fT.s.YY
	mov	[rdx].Matrix3fT.s.YY,eax;rot3->s.YY = NewObj->s.YY; 
	mov	eax,[rcx].Matrix4fT.s.YZ
	mov	[rdx].Matrix3fT.s.YZ,eax;rot3->s.YZ = NewObj->s.YZ;
	mov	eax,[rcx].Matrix4fT.s.ZX
	mov	[rdx].Matrix3fT.s.ZX,eax;rot3->s.ZX = NewObj->s.ZX; 
	mov	eax,[rcx].Matrix4fT.s.ZY
	mov	[rdx].Matrix3fT.s.ZY,eax;rot3->s.ZY = NewObj->s.ZY; 
	mov	eax,[rcx].Matrix4fT.s.ZZ
	mov	[rdx].Matrix3fT.s.ZZ,eax;rot3->s.ZZ = NewObj->s.ZZ;
; zero-div may occur.
	movss	xmm0,[rcx].Matrix4fT.s.XX
	mulss	xmm0,xmm0;(NewObj->s.XX * NewObj->s.XX)
	movss	xmm1,[rcx].Matrix4fT.s.XY
	mulss	xmm1,xmm1;(NewObj->s.XY * NewObj->s.XY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.XZ
	mulss	xmm1,xmm1;(NewObj->s.XZ * NewObj->s.XZ)
	addss	xmm0,xmm1
	rsqrtss	xmm0,xmm0
	movss	n,xmm0;n = 1.0/sqrt(  +
	movss	xmm1,[rdx].Matrix3fT.s.XX
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.XX,xmm1;rot3->s.XX *= n;
	movss	xmm1,[rdx].Matrix3fT.s.XY
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.XY,xmm1;rot3->s.XY *= n;
	movss	xmm1,[rdx].Matrix3fT.s.XZ
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.XZ,xmm1;rot3->s.XZ *= n;
	movss	xmm0,[rcx].Matrix4fT.s.YX
	mulss	xmm0,xmm0;(NewObj->s.YX * NewObj->s.YX)
	movss	xmm1,[rcx].Matrix4fT.s.YY
	mulss	xmm1,xmm1;(NewObj->s.YY * NewObj->s.YY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.YZ
	mulss	xmm1,xmm1;(NewObj->s.YZ * NewObj->s.YZ)
	addss	xmm0,xmm1
	rsqrtss	xmm0,xmm0
	movss	n,xmm0;n = 1.0/sqrt(++)
	movss	xmm1,[rdx].Matrix3fT.s.YX
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.YX,xmm1;rot3->s.YX *= n;
	movss	xmm1,[rdx].Matrix3fT.s.YY
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.YY,xmm1;rot3->s.YY *= n;
	movss	xmm1,[rdx].Matrix3fT.s.YZ
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.YZ,xmm1;rot3->s.YZ *= n;
	movss	xmm0,[rcx].Matrix4fT.s.ZX
	mulss	xmm0,xmm0;(NewObj->s.ZX * NewObj->s.ZX)
	movss	xmm1,[rcx].Matrix4fT.s.ZY
	mulss	xmm1,xmm1;(NewObj->s.ZY * NewObj->s.ZY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.ZZ
	mulss	xmm1,xmm1;(NewObj->s.ZZ * NewObj->s.ZZ)
	addss	xmm0,xmm1
	rsqrtss	xmm0,xmm0
	movss	n,xmm0;n = 1.0/sqrt(+ + );
	movss	xmm1,[rdx].Matrix3fT.s.ZX
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.ZX,xmm1;rot3->s.ZX *= n
	movss	xmm1,[rdx].Matrix3fT.s.ZY
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.ZY,xmm1;rot3->s.ZY *= n
	movss	xmm1,[rdx].Matrix3fT.s.ZZ
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.ZZ,xmm1;rot3->s.ZZ *= n;
@@:	or	r8d,r8d
	jz	exit0;if (rot4)   //if pointer not null
	mov	rax,NewObj
	cmp	rot4,rax
	jz	@f
	mov	edx,eax;NewObj
	invoke	Matrix4fSetRotationScaleFromMatrix4f,rot4; private method
@@:; zero-div may occur.
	mov	rcx,NewObj
	movss	xmm0,[rcx].Matrix4fT.s.XX
	mulss	xmm0,xmm0;(NewObj->s.XX * NewObj->s.XX)
	movss	xmm1,[rcx].Matrix4fT.s.XY
	mulss	xmm1,xmm1;(NewObj->s.XY * NewObj->s.XY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.XZ
	mulss	xmm1,xmm1;(NewObj->s.XZ * NewObj->s.XZ)
	addss	xmm0,xmm1
	rsqrtss	xmm0,xmm0
	movss	n,xmm0;n = 1.0/sqrt(++);
	mov	rdx,rot4
	movss	xmm1,[rdx].Matrix3fT.s.XX
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.XX,xmm1;rot4->s.XX *= n;
	movss	xmm1,[rdx].Matrix3fT.s.XY
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.XY,xmm1;rot4->s.XY *= n;
	movss	xmm1,[rdx].Matrix3fT.s.XZ
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.XZ,xmm1;rot4->s.XZ *= n;
	movss	xmm0,[rcx].Matrix4fT.s.YX
	mulss	xmm0,xmm0;(NewObj->s.YX * NewObj->s.YX)
	movss	xmm1,[rcx].Matrix4fT.s.YY
	mulss	xmm1,xmm1;(NewObj->s.YY * NewObj->s.YY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.YZ
	mulss	xmm1,xmm1;(NewObj->s.YZ * NewObj->s.YZ)
	addss	xmm0,xmm1
	rsqrtss	xmm0,xmm0
	movss	n,xmm0;n = 1.0/sqrt(++);
	movss	xmm1,[rdx].Matrix3fT.s.YX
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.YX,xmm1;rot4->s.YX *= n;
	movss	xmm1,[rdx].Matrix3fT.s.YY
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.YY,xmm1;rot4->s.YY *= n;
	movss	xmm1,[rdx].Matrix3fT.s.YZ
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.YZ,xmm1;rot4->s.YZ *= n;
	movss	xmm0,[rcx].Matrix4fT.s.ZX
	mulss	xmm0,xmm0;(NewObj->s.ZX * NewObj->s.ZX)
	movss	xmm1,[rcx].Matrix4fT.s.ZY
	mulss	xmm1,xmm1;(NewObj->s.ZY * NewObj->s.ZY)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Matrix4fT.s.ZZ
	mulss	xmm1,xmm1;(NewObj->s.ZZ * NewObj->s.ZZ)
	addss	xmm0,xmm1
	rsqrtss	xmm0,xmm0
	movss	n,xmm0;n = 1.0/sqrt(++)
	movss	xmm1,[rdx].Matrix3fT.s.ZX
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.ZX,xmm1;rot4->s.ZX *= n
	movss	xmm1,[rdx].Matrix3fT.s.ZY
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.ZY,xmm1;rot4->s.ZY *= n
	movss	xmm1,[rdx].Matrix3fT.s.ZZ
	mulss	xmm1,xmm0
	movss	[rdx].Matrix3fT.s.ZZ,xmm1;rot4->s.ZZ *= n;
	movss	xmm0,s
exit0:	leave
	ret
Matrix4fSVD endp
Matrix4fSetRotationScaleFromMatrix3f proc NewObj:qword,m1:qword;Matrix4fT* NewObj, const Matrix3fT* m1)
	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0;assert(NewObj && m1);
	mov	eax,[rdx].Matrix3fT.s.XX
	mov	[rcx].Matrix4fT.s.XX,eax; NewObj->s.XX = m1->s.XX
	mov	eax,[rdx].Matrix3fT.s.YX
	mov	[rcx].Matrix4fT.s.YX,eax; NewObj->s.YX = m1->s.YX
	mov	eax,[rdx].Matrix3fT.s.ZX
	mov	[rcx].Matrix4fT.s.ZX,eax; NewObj->s.ZX = m1->s.ZX;
	mov	eax,[rdx].Matrix3fT.s.XY
	mov	[rcx].Matrix4fT.s.XY,eax; NewObj->s.XY = m1->s.XY
	mov	eax,[rdx].Matrix3fT.s.YY
	mov	[rcx].Matrix4fT.s.YY,eax; NewObj->s.YY = m1->s.YY
	mov	eax,[rdx].Matrix3fT.s.ZY
	mov	[rcx].Matrix4fT.s.ZY,eax; NewObj->s.ZY = m1->s.ZY;
	mov	eax,[rdx].Matrix3fT.s.XZ
	mov	[rcx].Matrix4fT.s.XZ,eax; NewObj->s.XZ = m1->s.XZ
	mov	eax,[rdx].Matrix3fT.s.YZ
	mov	[rcx].Matrix4fT.s.YZ,eax; NewObj->s.YZ = m1->s.YZ
	mov	eax,[rdx].Matrix3fT.s.ZZ
	mov	[rcx].Matrix4fT.s.ZZ,eax; NewObj->s.ZZ = m1->s.ZZ;
exit0:	leave
	ret
Matrix4fSetRotationScaleFromMatrix3f endp
Matrix4fMulRotationScale proc NewObj:qword,scale:dword;Matrix4fT* NewObj, GLfloat scale)
	or	ecx,ecx
	jz	exit0;assert(NewObj);
	movss	xmm0,[rcx].Matrix4fT.s.XX
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.XX,xmm0;NewObj->s.XX *= scale
	movss	xmm0,[rcx].Matrix4fT.s.YX
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.YX,xmm0; NewObj->s.YX *= scale
	movss	xmm0,[rcx].Matrix4fT.s.ZX
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.ZX,xmm0; NewObj->s.ZX *= scale;
	movss	xmm0,[rcx].Matrix4fT.s.XY
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.XY,xmm0;NewObj->s.XY *= scale
	movss	xmm0,[rcx].Matrix4fT.s.YY
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.YY,xmm0; NewObj->s.YY *= scale
	movss	xmm0,[rcx].Matrix4fT.s.ZY
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.ZY,xmm0; NewObj->s.ZY *= scale;
	movss	xmm0,[rcx].Matrix4fT.s.XZ
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.XZ,xmm0;NewObj->s.XZ *= scale
	movss	xmm0,[rcx].Matrix4fT.s.YZ
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.YZ,xmm0; NewObj->s.YZ *= scale
	movss	xmm0,[rcx].Matrix4fT.s.ZZ
	mulss	xmm0,xmm1
	movss	[rcx].Matrix4fT.s.ZZ,xmm0; NewObj->s.ZZ *= scale;
exit0:	leave
	ret
Matrix4fMulRotationScale endp
_mapToSphere proc NewPt:qword, NewVec:qword
local	TempPt:Point2fT
local	length_:dword
local	norm:dword
	mov	NewPt,rcx
	mov	NewVec,rdx
;Copy paramter into temp point
	mov	rax,[rcx]
	mov	TempPt,rax;TempPt = *NewPt
;Adjust point coords and scale down to range of [-1 ... 1]
	movss	xmm0,TempPt.s.x
	mulss	xmm0,AdjustWidth
	subss	xmm0,const1
	movss	TempPt.s.x,xmm0;TempPt.s.X=TempPt.s.X*AdjustWidth - 1.0
	movss	xmm0,TempPt.s.y
	mulss	xmm0,AdjustHeight
	movss	xmm1,const1
	subss	xmm1,xmm0
	movss	TempPt.s.y,xmm1;TempPt.s.Y=1.0-(TempPt.s.Y*AdjustHeight)
;Compute the square of the length of the vector to the point from the center
	movss	xmm0,TempPt.s.x
	mulss	xmm0,xmm0
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	length_,xmm0;length_=(TempPt.s.X*TempPt.s.X)+(TempPt.s.Y*TempPt.s.Y)
;If the point is mapped outside of the sphere... (length > radius squared)
	mov	rax,NewVec
        comiss	xmm0, const1
	jbe	@f;if (length > 1.0)
	rsqrtss	xmm0,xmm0
;Compute a normalizing factor (radius / sqrt(length))
	movss	norm,xmm0;norm = 1.0/Sqrt(length);
;Return the "normalized" vector, a point on the sphere
	mulss	xmm0,TempPt.s.x
        movss	[rax].Vector3fT.s.X,xmm0;NewVec->s.X = TempPt.s.X * norm
	movss	xmm0,TempPt.s.y
	mulss	xmm0,norm
	movss	[rax].Vector3fT.s.Y,xmm0;NewVec->s.Y = TempPt.s.Y * norm
	and	[rax].Vector3fT.s.Z,0;NewVec->s.Z = 0.0f;
	jmp	@0
@@:;Else it's on the inside
;Return a vector to a point mapped inside the sphere sqrt(radius squared - length)
	movss	xmm0,TempPt.s.x
	movss	[rax].Vector3fT.s.X,xmm0;NewVec->s.X = TempPt.s.X
	movss	xmm0,TempPt.s.y
	movss	[rax].Vector3fT.s.Y,xmm0;NewVec->s.Y = TempPt.s.Y
	movss	xmm0,const1
	subss	xmm0,length_
	sqrtss	xmm0,xmm0
	movss	[rax].Vector3fT.s.Z,xmm0;NewVec->s.Z = sqrt(1.0 - length);
@0:	leave
	ret
_mapToSphere endp
Vector3fCross proc NewObj:qword,v10:qword,v20:qword;Vector3fT* NewObj, const Vector3fT* v1, const Vector3fT* v2)
local	Result:Vector3fT;safe not to initialize
	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0
	or	r8d,r8d
	jz	exit0;assert(NewObj && v1 && v2);
; store on stack once for aliasing-safty
; i.e. safe when a.cross(a, b)
	movss	xmm0,[rdx].Vector3fT.s.Y
	mulss	xmm0,[r8].Vector3fT.s.Z
	movss	xmm1,[rdx].Vector3fT.s.Z
	mulss	xmm1,[r8].Vector3fT.s.Y
	subss	xmm0,xmm1
	movss	Result.s.X,xmm0;Result.s.X = (v1->s.Y * v2->s.Z) - (v1->s.Z * v2->s.Y)
	movss	xmm0,[rdx].Vector3fT.s.Z
	mulss	xmm0,[r8].Vector3fT.s.X
	movss	xmm1,[rdx].Vector3fT.s.X
	mulss	xmm1,[r8].Vector3fT.s.Z
	subss	xmm0,xmm1
	movss	Result.s.Y,xmm0;Result.s.Y = (v1->s.Z * v2->s.X) - (v1->s.X * v2->s.Z)
	movss	xmm0,[rdx].Vector3fT.s.X
	mulss	xmm0,[r8].Vector3fT.s.Y
	movss	xmm1,[rdx].Vector3fT.s.Y
	mulss	xmm1,[r8].Vector3fT.s.X
	subss	xmm0,xmm1
	movss	Result.s.Z,xmm0;Result.s.Z = (v1->s.X * v2->s.Y) - (v1->s.Y * v2->s.X)
;copy result back
	push	rsi
	push	rdi
        mov	edi,ecx;NewObj
	lea	esi,Result
	mov	ecx,3
	rep	movsd;*NewObj = Result
	pop	rdi
	pop	rsi        
exit0:	leave
	ret
Vector3fCross endp

Vector3fLengthSquared proc NewObj:qword;Vector3fT* NewObj)
	or	ecx,ecx
	jz	exit0;assert(NewObj);
	movss	xmm0,[rcx].Vector3fT.s.X
	mulss	xmm0,xmm0;(NewObj->s.X * NewObj->s.X)
	movss	xmm1,[rcx].Vector3fT.s.Y
	mulss	xmm1,xmm1;(NewObj->s.Y * NewObj->s.Y)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Vector3fT.s.Z
	mulss	xmm1,xmm1;(NewObj->s.Z * NewObj->s.Z)
	addss	xmm0,xmm1
exit0:	leave
	ret
Vector3fLengthSquared endp
Vector3fDot proc;Vector3fT* NewObj, const Vector3fT* v1)
	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0;assert(NewObj && v1);
	movss	xmm0,[rcx].Vector3fT.s.X
	mulss	xmm0,[rdx].Vector3fT.s.X;(NewObj->s.X * v1->s.X)
	movss	xmm1,[rcx].Vector3fT.s.Y
	mulss	xmm1,[rdx].Vector3fT.s.Y;(NewObj->s.Y * v1->s.Y)
	addss	xmm0,xmm1
	movss	xmm1,[rcx].Vector3fT.s.Z
	mulss	xmm1,[rdx].Vector3fT.s.Z;(NewObj->s.Z * v1->s.Z)
	addss	xmm0,xmm1
exit0:	leave
	ret
Vector3fDot endp
Matrix4fSetRotationScaleFromMatrix4f proc NewObj:qword,m1:qword;Matrix4fT* NewObj, const Matrix3fT* m1
	or	ecx,ecx
	jz	exit0
	or	edx,edx
	jz	exit0;assert(NewObj && m1);
	mov	eax,[rdx].Matrix3fT.s.XX
	mov	[rcx].Matrix4fT.s.XX,eax;NewObj->s.XX = m1->s.XX
	mov	eax,[rdx].Matrix3fT.s.YX
	mov	[rcx].Matrix4fT.s.YX,eax;NewObj->s.YX = m1->s.YX
	mov	eax,[rdx].Matrix3fT.s.ZX
	mov	[rcx].Matrix4fT.s.ZX,eax;NewObj->s.ZX = m1->s.ZX;
	mov	eax,[rdx].Matrix3fT.s.XY
	mov	[rcx].Matrix4fT.s.XY,eax;NewObj->s.XY = m1->s.XY
	mov	eax,[rdx].Matrix3fT.s.YY
	mov	[rcx].Matrix4fT.s.YY,eax; NewObj->s.YY = m1->s.YY
	mov	eax,[rdx].Matrix3fT.s.ZY
	mov	[rcx].Matrix4fT.s.ZY,eax; NewObj->s.ZY = m1->s.ZY;
	mov	eax,[rdx].Matrix3fT.s.XZ
	mov	[rcx].Matrix4fT.s.XZ,eax;NewObj->s.XZ = m1->s.XZ
	mov	eax,[rdx].Matrix3fT.s.YZ
	mov	[rcx].Matrix4fT.s.YZ,eax; NewObj->s.YZ = m1->s.YZ
	mov	eax,[rdx].Matrix3fT.s.ZZ
	mov	[rcx].Matrix4fT.s.ZZ,eax; NewObj->s.ZZ = m1->s.ZZ
exit0:  leave
	ret
Matrix4fSetRotationScaleFromMatrix4f endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName db "NeHe lesson#48: Grant's ArcBall Rotation Tutorial",0
FileName    db "br_Rabbit3.cur",0
quadratic   	dq ?
Transform   	dd 3 dup(1.0,4 dup(0)),1.0; Final Transform          
LastRot     	dd 2 dup(1.0,3 dup(0)),1.0; Last Rotation
ThisRot	    	dd 2 dup(1.0,3 dup(0)),1.0; This Rotation
MousePt 	Point2fT <>; Current Mouse Point
isClicked  	db FALSE; Clicking The Mouse?
isRClicked 	db FALSE; Clicking The Right Mouse Button?
isLClicked 	db FALSE; Clicking The Mouse?
isDragging 	db FALSE; Dragging The Mouse?
ThisQuat   	Quat4fT <>
PI2		dd 6.28318530717958647692528676656
AdjustHeight	dd ?;Mouse bounds height
AdjustWidth	dd ?;Mouse bounds width 
StVec 		Vector3fT <>;Saved click vector
EnVec 		Vector3fT <>;Saved drag vector
;-----------------------------
;float
Epsilon 	dd 0.00001
const0_01 	dd 0.01
const0_05	dd 0.05
const0_3	dd 0.3
const0_5	dd 0.5
const0_75	dd 0.75
const1		dd 1.0
const1_5	dd 1.5
const_1_5	dd -1.5
const2		dd 2.0
const3		dd 3.0
const_6		dd -6.0
const0_Pi	dd 0.31415926535897932384626433833
const7		dd 7.0
const20		dd 20.0
;double
constd1		dq 1.0
constd1_3	dq 1.3
constd45	dq 45.0
constd100	dq 100.0
end